#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

module SidfmCatGroupsHelper
  # サマリー表のチェックボックス
  def create_summary_cat_group_chkbox(id, checked)
    content = check_box_tag(
      nil,
      id,
      checked.include?(id),
      :class => 'groupSelect'
    )
  end

  #サマリー表のid
  def create_summary_cat_group_id(id)
    content = content_tag(:div, id, :class => 'text-left')
  end

  # サマリー表のグループ名
  def create_summary_cat_group_name(name)
    content = content_tag(:div, name, :class => 'text-left')
  end

  # サマリー表のカテゴリ
  def create_summary_cat_group_categories(display_category, categories_count, group_id)
    content = content_tag(:div, '---', :class => 'text-left')
    if display_category then
      if categories_count == 1 then
        content = content_tag(:div, :class => 'text-left') do
          concat(
            content_tag(
              :a,
              display_category[:name],
              :href => '#',
              :class => 'ignore-click text-ellipsis d-block summary-category-name',
              :data => {
                :toggle => 'tooltip',
                :title => display_category[:desc],
                :placement => 'right',
                :boundary => 'window',
                :filteritem => 'category_id',
                :name => 'category_id',
                :value => display_category[:id]
              }
            )
          )
        end
      elsif categories_count > 1 then
        content = content_tag(:div, :class => 'text-left overflow-auto') do
          concat(
            create_summary_items_balloon(
              [],
              categories_count,
              display_category[:name],
              {
                :button_class => 'show-group-categories summary-category-btn',
                :button_inner_text_style => 'overflow: hidden; white-space: nowrap; text-overflow: ellipsis; margin-right: 2px;',
                :button_data => { :groupid => group_id }
              }
            )
          )
        end
      end
    end
    content
  end

  # サマリー表の操作
  def create_summary_cat_group_edit(id, name)
    content = content_tag(
      :div,
      :class => 'd-flex justify-content-center'
    ) do
      concat(
        button_tag(
          '編集',
          :type => 'button',
          :class => 'btn btn-sm btn-edit mr-1 text-nowrap',
          :data => { :groupid => id, :name => name, :edit => 'true' },
        ) 
      )
      .concat(
        button_tag(
          '削除',
          :type => 'button',
          :class => 'btn btn-sm btn-danger text-nowrap',
          :data => { :groupid => id, :name => name, :delete => 'true' },
        )
      )
    end
  end

end
