#!/usr/bin/env ruby
# -*- coding: utf-8 -*-

module SidfmLocalVulsHelper

  # サマリー表のチェックボックス
  def create_summary_local_vul_chkbox(lvul_id, checked)
    content = check_box_tag(
      nil,
      lvul_id,
      checked.include?(lvul_id),
      :class => 'SelectVul'
    )
  end
 
  # サマリー表の脆弱性名
  def create_summary_local_vul_name(name)
    content_tag(
      :div,
      "#{name}",
      :class => "g-line-height-1_2 text-truncate",
      :style => "max-width: 600px;"
    )
  end

  # サマリー表の最終更新日時
  def create_summary_local_vul_updated_at(updated_at)
    content_tag(:div, "#{updated_at}")
  end

  # サマリー表の有効/無効
  def create_summary_local_vul_status(flg_enable)
    content = flg_enable ?
      content_tag(:span, "有効", :class => "badge badge-success g-font-size-0_93x font-weight-normal text-nowrap") :
      content_tag(:span, "無効", :class => "badge badge-secondary g-font-size-0_93x font-weight-normal text-nowrap")
  end

  # サマリー表の詳細
  def create_summary_local_vul_detail(html_id)
    link_to(
      '脆弱性情報の詳細',
      { :controller => :sidfm_informations, :action => :vuln, :id => html_id },
      :class => 'g-text-ul' 
    )
  end

  # サマリー表の操作
  def create_summary_local_vul_edit(vul, sidfm_roles)
    content =
      if sidfm_roles.include?(:admin) then
        content_tag(
          :div,
          :class => "d-flex justify-content-center"
        ) do
          concat(
            button_tag(
              '編集',
              :type => 'button',
              :class => 'btn btn-edit btn-sm edit-vul mr-1',
              :data => { :param => vul.to_json, :vuleditid => vul[:id] }
            )
          )
          .concat(
            form_tag(
              { :controller => :sidfm_local_vuls, :action => :delete },
              :id => "delete-form-#{vul[:id]}"
            ) do
              concat(
                hidden_field_tag("form[delete_id]", "#{vul[:id]}")
              )
              .concat(
                button_tag(
                  '削除',
                  :type => 'button',
                  :class => 'btn btn-danger btn-sm delete-vul',
                  :data => { :deleteid => vul[:id] }
                )
              )
            end
          )
        end
      else
        button_tag("編集", :type => "button", :class => "btn btn-edit btn-sm mr-1 disabled")
        .concat( button_tag("削除", :type => "button", :class => "btn btn-danger btn-sm disabled") )
      end
  end

end

