# -*- coding: utf-8 -*-

class SidfmdRuleTrigger < ActiveRecord::Base
  belongs_to :sidfmd_rule

  # 以下、どれか一つのみになるように編集すること。
  has_one :sidfmd_rule_tp_hour, dependent: :delete
  has_one :sidfmd_rule_tp_interval, dependent: :delete
  has_one :sidfmd_rule_t_vulsync, dependent: :delete

  def detail
    case
    when sidfmd_rule_tp_hour then sidfmd_rule_tp_hour
    when sidfmd_rule_tp_interval then sidfmd_rule_tp_interval
    when sidfmd_rule_t_vulsync then sidfmd_rule_t_vulsync
    else nil
    end
  end 

  # ログを追加する
  def log(type, message)
    self.with_lock do
      self.update_attribute :logs, SidfmdRule.log_append(self.logs, type, SidfmdRule::LOG_TRIGGER, message)
    end
  end

  def log_info(message)
    log(SidfmdRule::LOG_INFO, message)
  end

  def log_warn(message)
    log(SidfmdRule::LOG_WARN, message)
  end

  def log_err(message)
    log(SidfmdRule::LOG_ERR, message)
  end

end
