/* Copyright (C) 2018 SofTek Systems, Inc. */

// サイドメニュー用
// 全画面に影響する初期化もこちらで設定。

function applyDropdownToggle() {
    $('.dropdown-menu a.dropdown-toggle').on('click', function(ev) {
	if (!$(this).next().hasClass('show')) {
	    $(this).parents('.dropdown-menu').first().find('.show').removeClass("show");
	}
	var $subMenu = $(this).next(".dropdown-menu");
	$subMenu.toggleClass('show');
	$(this).parents('.dropdown.show').on('hidden.bs.dropdown', function() {
	    $('.dropdown-submenu .show').removeClass("show");
	});
	$(this).parents('.dropright.show').on('hidden.bs.dropdown', function() {
	    $('.dropdown-submenu .show').removeClass("show");
	});
	return false;
    });
}

$(function () {

    init_sidfm();

    // mCustomScrollbar の初期化、テーマ選択
    $("#sidebar").mCustomScrollbar({
        theme: "minimal",
        scrollInertia: 0,
    });

    // sidebar dropdown 制御(JQUERY)
    (function() {
	// 開閉状態の保持 (sesson only)
	var c = $.cookie('sidebar_opened');
	if (c) {
	    c = ("true" === c);
	    if (!c) {
		$('#sidebar, #content-block').addClass('active');
	    }
	} else {
	    // 開いた状態をデフォルトとする
	    $.cookie('sidebar_opened', 'true');
	}
    })();
    // 画面表示、リサイズの際に、ウインドウサイズに応じて開閉する
    (function() {
        var t = $('#sidebar, #content-block');
        var sW = window.innerWidth;
        if (sW < 1200) {
            t.addClass('auto-active');
        }
        $(window).on('load resize', function() {
            var windowWidth = window.innerWidth;
            if (windowWidth < 1200) {
                t.addClass('auto-active');
            } else {
                t.removeClass('auto-active');
            }
            if( windowWidth >= 1200 && $.cookie('sidebar_opened') === 'true'){
                $('#up-sidebar-menu-button, #down-sidebar-menu-button').show();
            }else{
                $('#up-sidebar-menu-button, #down-sidebar-menu-button').hide();
            } 
        });
    })();
    // 開閉ボタンを押下した際に開閉する
    $('#SidebarCollapse').on('click', function () {
        var t = $('#sidebar, #content-block');
        if (t.hasClass('auto-active')) {
            t.removeClass('auto-active');
            t.addClass('active');
            $.cookie('sidebar_opened', 'true');
        }
        if (t.hasClass('active')) {
            $.cookie('sidebar_opened', 'true');
            setTimeout(function(){
                $('#up-sidebar-menu-button, #down-sidebar-menu-button').show();
            }, 250);
        } else {
            $.cookie('sidebar_opened', 'false');
            $('#up-sidebar-menu-button, #down-sidebar-menu-button').hide();
        }
        t.toggleClass('active');
        $('.collapse.in').toggleClass('in');
        $('a[aria-expanded=true]').attr('aria-expanded', 'false');
        if($('#floating-scroll').length != 0){
            setTimeout(set_scroll, 200);
        }   
    });

    var sidebar_scrolling = null;

    function stop_sidebar_scroll(){
        clearInterval(sidebar_scrolling);
    }

    function scroll_sidebar(scroll_size, max_scroll_size, is_up){
        sidebar_scrolling = setInterval(function(){
            scroll_size += 5; //ここの数値を変えるだけ移動量(スクロールのスピード)が変更可
            if( scroll_size > max_scroll_size ){
                $('#sidebar').mCustomScrollbar('scrollTo', (is_up ? max_scroll_size : -max_scroll_size));
                stop_sidebar_scroll();
            }else{
                $('#sidebar').mCustomScrollbar('scrollTo', (is_up ? scroll_size : -scroll_size));
            }
        });
    }

    $('#up-sidebar-menu-button').on('mousedown', function(){
        $('#down-sidebar-menu-button').removeClass('scroll-side');
        $(this).addClass('scroll-side');
        var scroll_size = parseInt($('.mCSB_container').css('top').replace('px', ''));
        scroll_sidebar(scroll_size, 0, true);
    });

    $('#down-sidebar-menu-button').on('mousedown', function(){
        $('#up-sidebar-menu-button').removeClass('scroll-side');
        $(this).addClass('scroll-side');
        var container_height = $('.mCSB_container').get(0).scrollHeight;
        var window_height = $(window).height();
        var head_height = $('#HEADnavi').outerHeight(true);
        var sidebar_padding_bottom = $('#sidebar').css('padding-bottom').replace('px', '');
        var max_scroll_size = container_height + head_height - window_height + (sidebar_padding_bottom ? parseInt(sidebar_padding_bottom) : 0);
        var next_scroll_size = -(parseInt($('.mCSB_container').css('top').replace('px', '')));
 
        scroll_sidebar(next_scroll_size, max_scroll_size);
    });

    $('#up-sidebar-menu-button, #down-sidebar-menu-button').on('mouseup', function(){
        stop_sidebar_scroll();
    }); 
    
    //$('#up-sidebar-menu-button').on('click', function(){
        //$('#sidebar').mCustomScrollbar('scrollTo', 'top');
        /*アニメーションで動作する実装
        $('#sidebar').mCustomScrollbar('update');
        $('.mCSB_container').animate({ top : 0 }, 350, 'linear');
        */
    //});
    //$('#down-sidebar-menu-button').on('click', function(){
        //$('#sidebar').mCustomScrollbar('scrollTo', 'bottom');
        /*アニメーションで動作する実装
        $('#sidebar').mCustomScrollbar('update');
        var container_height = $('.mCSB_container').get(0).scrollHeight;
        var window_height = $(window).height();
        var head_height = $('#HEADnavi').outerHeight(true);
        var sidebar_padding_bottom = $('#sidebar').css('padding-bottom').replace('px', '');
        var scroll_size = container_height + head_height - window_height + (sidebar_padding_bottom ? parseInt(sidebar_padding_bottom) : 0);
        $('.mCSB_container').animate({ top : -scroll_size}, 350, 'linear');
        */
    //});

    
 
    applyDropdownToggle();

    //カテゴリ名検索
    $('#sidemenu_custom_categories_search').on('input', function(){
        const val = $(this).val();
        const oldValElm = $('#sidemenu_custom_categories_search_old');
        if( val != oldValElm.val() ){
            oldValElm.val(val);
            const listElm = $('#sidebar-select-custom-categories-list');
            $.post($('#sidemenu_api_search_category_path').val(), { name: val }, function(cats){
                const options = cats.map(function(cat, idx) {
                    return $('<option>').attr({
                        'data-toggle': 'tooltip',
                        'data-title': cat.desc,
                        'data-placement': 'right',
                        'data-boundary': 'window'
                    }).val(cat.id).text(cat.name);
                });
                $('#sidebar-select-custom-categories [data-toggle="tooltip"]').tooltip('hide');
                listElm.find('option').remove();
                listElm.append(options);
                listElm.find('[data-toggle="tooltip"]').tooltip();
                listElm.find('option').on('click', function(){
                    const hostsPath = $('#sidemenu_custom_categories_hosts_path').val();
                    const catId = $(this).val();
                    location.href = hostsPath.slice(0, hostsPath.length - 1) + catId;
                    return false;
                });
            });
        }
    });

    // ホスト名検索
    $('#sidemenu_hostsearch').on('keyup', function(ev) {
        $('[data-toggle="tooltip"]').tooltip('hide');
        var f = $(this);
        var f_val = f.val();
        var old_f = $('#sidemenu_hostsearch_old');
        if (f_val != old_f.val()) {
            old_f.val(f_val);
            var path = $('#sidfm_internal_api_hosts_path').val();
            $.get(path, { 'params[keyword]': f_val }, function(data) {
                if(data != null){
                    var options = $.map(data, function(n, i) {
                        var ext_name = n.ext_name;
                        var hostname = n.hostname;
                        var regexp = new RegExp(f_val.toLowerCase().replace(/\\/g, '\\\\'));
                        var hit_name = (ext_name && ext_name.toLowerCase().match(regexp)) ? ext_name : hostname;
                        var option = $('<option></option>', {
                            value: n.id,
                            text: hit_name,
                            'class': 'sidebar-select-hostlist-link',
                            'data-hostid': n.id,
                            'data-toggle': 'tooltip',
                            'data-title': 'ホスト名: ' + hostname + '<br/>表示名: ' + (ext_name ? ext_name : '(未設定)'),
                            'data-placement': 'right',
                            'data-html': 'true',
                            'data-boundary': 'window'
                        });
                        return option;
                    });
                    $('#sidebar-select-hostlist > option').remove();
                    $('#sidebar-select-hostlist').append(options);
                    $('#sidebar-select-hostlist').find('[data-toggle="tooltip"]').tooltip();
                }else{
                    $('#sidebar-select-hostlist > option').remove();
                }
                $('.sidebar-select-hostlist-link').on('click', function() {
                    var e = $(this);
                    var hostid = e.data('hostid'); 
                    location.href = url_host_detail(hostid);
                    return false;
                });
            });
            ev.preventDefault();
        }
        return true;
    });

    // 脆弱性検索 : 危険度指標
    $('.sidemenu-vulssearch-riskmenu').on('click', function(ev) {
	var link = $(this);
	var rtype = link.data('riskmenu-type');
	var level = link.data('riskmenu-level');
	var unit = link.data('riskmenu-unit');
	var num = link.data('riskmenu-num');
	var ul = link.next('ul');
	ul.children('li').remove();
	var path = $('#sidfm_internal_api_vulnerabilities_risk_period_path').val();
	$.get(path, {
	    'params[risk_type]': rtype,
	    'params[risk_level]': level,
	    'params[unit]': unit,
	    'params[num]': num
	}, function(data) {
	    if (data.length > 0) {
		var items = $.map(data, function(n, i) {
		    var li = $('<li></li>');
		    var a = $('<a></a>', {
			class: 'dropdown-item',
			href: url_vulnerabilities_detail(n.html_id)
		    });
		    a.text(n.created_on + ' ' + n.title);
		    li.append(a);
		    return li;
		});
		ul.append(items);
	    } else {
		var item = $('<li></li>');
		var a = $('<a></a>', {
		    class: 'dropdown-item',
		    href: '#'
		});
		a.text('指定の期間には脆弱性は登録されておりません。');
		item.append(a);
		ul.append(item);
	    }
	    applyDropdownToggle();
	});
	return true;
    });

    // 脆弱性検索 : 検出時期
    $('.sidemenu-vulssearch-timemenu').on('click', function(ev) {
	var link = $(this);
	var unit = link.data('timemenu-unit');
	var num = link.data('timemenu-num');
	var ul = link.next('ul');
	ul.children('li').remove();
	var path = $('#sidfm_internal_api_vulnerabilities_period_path').val();
	$.get(path, {
	    'params[unit]': unit, 'params[num]': num
	}, function(data) {
	    if (data.length > 0) {
		var items = $.map(data, function(n, i) {
		    var li = $('<li></li>');
		    var a = $('<a></a>', {
			class: 'dropdown-item',
			href: url_vulnerabilities_detail(n.html_id)
		    });
		    a.text(n.created_on + ' ' + n.title);
		    li.append(a);
		    return li;
		});
		ul.append(items);
	    } else {
		var item = $('<li></li>');
		var a = $('<a></a>', {
		    class: 'dropdown-item disabled',
		    href: '#'
		});
		a.text('指定の期間には脆弱性は登録されておりません。');
		item.append(a);
		ul.append(item);
	    }
	    applyDropdownToggle();
	});
	return true;
    });

    // 脆弱性検索
    $('#sidemenu_vulsearch').on('keyup', function(ev) {
	var f = $(this);
	var old_f = $('#sidemenu_vulsearch_old');
	if (f.val() != old_f.val()) {
	    old_f.val(f.val());
	    if (f.val().length == 0) {
 		$('#sidebar-select-vullist > option').remove();
		return true;
	    }
	    var path = $('#sidfm_internal_api_vulnerabilities_path').val();
	    $.get(path, { 'params[keyword]': f.val() }, function(data) {
                if(data != null){
		    var options = $.map(data, function(n, i) {
		        var option = $('<option></option>', {
			    value: n['html_id'],
			    text: n['title'],
			    'class': 'sidebar-select-vullist-link',
			    'data-htmlid': n['html_id']
		        });
		        return option;
		    });
 		    $('#sidebar-select-vullist > option').remove();
		    $('#sidebar-select-vullist').append(options);
		    $('.sidebar-select-vullist-link').on('click', function(evt) {
		        evt.preventDefault();
		        var e = $(this);
		        var htmlid = e.data('htmlid');
		        location.href = url_vulnerabilities_detail(htmlid);
		        return true;
		    });
                }
            });
	    ev.preventDefault();
	    return true;
	}
	return true;
    });


});

// bootstrapとjquery-uiの競合対策
$.widget.bridge('uibutton', $.ui.button);
$.widget.bridge('uitooltip', $.ui.tooltip);
