# -*- coding: utf-8 -*-

class AddOpenidconnect < ActiveRecord::Migration
  # "OpenIDConnect"というダミーの認証方式を作成する

  AUTH_SOURCE_NAME = 'OpenIDConnect'

  def up
    # 重複登録のみ避ける
    AuthSource.transaction do
      as = AuthSource.lock.find_by_name(AUTH_SOURCE_NAME)
      unless as then
        AuthSource.create(name: AUTH_SOURCE_NAME)
      end
    end
  end

  def down
    # 一度登録したら削除しない
  end
end
